float iv = 0.5;  // initial velocity
float rf = 0.1;  // repulsive force
float sf = 0.1;  // syntonize force
float gf = 0.1;  // gravitational force

int r = 5;
int n = 100;
float[] px = new float[n];
float[] py = new float[n];
float[] sx = new float[n];
float[] sy = new float[n];

void setup(){
  size(480, 480);
  ellipseMode(CENTER);
  for(int i = 0; i < n; i++){
    px[i] = random(width * 0.2, width * 0.5);
    py[i] = random(height* 0.2, height* 0.5);
    sx[i] = random(0, iv);
    sy[i] = random(0, iv);
  }
}

void draw(){
  float gx = 0;
  float gy = 0;
  float lx, ly, l;
  background(0);
  for(int i = 0; i < n; i++){
    arc(px[i], py[i], r, r, 0, PI);
    gx += px[i] / n;
    gy += py[i] / n;
  }
  for(int i = 0; i < n; i++){
    int k = n;
    float s = width;
    for(int j = 0; j < n; j++){  // nearest
      if(j == i)  continue;
      lx = px[i] - px[j];
      ly = py[i] - py[j];
      l = sqrt(lx * lx + ly * ly);
      if(l < s){
        s = l;
        k = j;
      }
    }
    if(k < n){
      if(s < r * 5){             // proximity
        sx[i] += rf * (px[i] - px[k]) / s;
        sy[i] += rf * (py[i] - py[k]) / s;
      }else{                     // direction
        sx[i] = (sx[i] + sx[k] * sf) / (1 + sf);
        sy[i] = (sy[i] + sy[k] * sf) / (1 + sf);
      }
    }
    lx = gx - px[i];            // gravity
    ly = gy - py[i];
    l = sqrt(lx * lx + ly * ly);
    sx[i] += gf * lx / l;
    sy[i] += gf * ly / l;
    px[i] += sx[i];
    py[i] += sy[i];
    if(px[i] < 0 || width < px[i]){
      sx[i] = -sx[i];
    }
    if(py[i] < 0 || height< py[i]){
      sy[i] = -sy[i];
    }
  }
}
